<?php

namespace Slovocast\Domain\Repository\Channel;

use Slovocast\Domain\Repository\ChannelRepositoryInterface;
use Slovocast\Domain\Entity\Channel;
use Slovocast\Domain\Entity\User;
use Slovocast\Exception\EntityNotFoundException;
use React\Mysql\MysqlClient;
use function React\Async\await;

class ChannelRepository implements ChannelRepositoryInterface
{
    public function __construct(
        protected MysqlClient $db
    ) { }

    protected function createChannelFromResults(array $results): Channel
    {
        return Channel::fromArray([
            'name' => $results['name']
        ]);
    }

    public function get(int $id): Channel
    {
        $query = "SELECT * FROM channels WHERE id = ?";
        $results = await($this->db->query($query, [ $id ]));

        if (!count($results->resultRows)) {
            throw new EntityNotFoundException("Unable to find Channel");
        }

        return $this->createChannelFromResults($results->resultRows[0]);
    }

    public function getFromUser(User $user): Channel
    {

    }

    public function getFromSlug(string $slug): Channel
    {

    }
}
